c=======================================================================
c***********************************************************************
      subroutine pft_estab(ngt)
c***********************************************************************
c=======================================================================
      implicit none
c=======================================================================
c     This routine estimates establishment success for plant types.
c=======================================================================

      include './com_18/parameter.common'
      include './com_18/annee.common'
      include './com_18/climin0.common'
      include './com_18/climin.common'
      include './com_18/coord.common'
      include './com_18/cstmort.common'
      include './com_18/cte.common'
      include './com_18/disper.common'
      include './com_18/ecoin.common'
      include './com_18/estab.common'
      include './com_18/gddpix.common'
      include './com_18/inidata.common'
      include './com_18/monthcst.common'
      include './com_18/nspc.common'
      include './com_18/pho_sch.common'
      include './com_18/monwat.common'
      include './com_18/snow.common'
      include './com_18/temper.common'
      include './com_18/xlaic.common'

      real*4 watmin
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer , intent(in) :: ngt
      
      integer im,ip,mmm
      real*4 tot_frac

c------------------------------------------------  

      watmin = 1000.
      do im = 1, nm
       if (swcar(im).le.watmin) then
         watmin = swcar(im)
       endif
      enddo

      if (ifrac.eq.1) then
         do ip = 1, npft
         
            gdd_inf(ip) = gdd_est(ip) * (1.- delta_gdd5)
            gdd_sup(ip) = gdd_est(ip) * (1.+ delta_gdd5)
            
            Tmmin_inf(ip) = tcmax_est(ip) - delta_tmax
            Tmmin_sup(ip) = tcmax_est(ip) + delta_tmax
            
            watmin_inf(ip) = watmax_est(ip) * (1. -delta_watmax)
            watmin_sup(ip) = watmax_est(ip) * (1. +delta_watmax)

            tot_frac = 0.
            ylaimax_mean = 0.
      
            do mmm = 2, 17
             if(mmm.ne.ip) then
              ylaimax_mean = ylaimax_mean 
     &          + yfrac_ini(mmm,ngt)*ylaimax_ini(mmm,ngt)
              tot_frac = tot_frac + yfrac_ini(mmm,ngt)
             endif
            enddo
      
            ylaimax_mean = ylaimax_mean/tot_frac  
            
            ylai_inf = 1.
            ylai_sup = 2.
            ylai_est = 1.5          

            suc_est(ip,ngt) = pgerm(ip)
            if (gdd5.lt.gdd_inf(ip)) suc_est(ip,ngt) = 0.
            if (Tmmin.gt.Tmmin_sup(ip)) suc_est(ip,ngt) = 0.
            if (watmin.gt.watmin_sup(ip)) suc_est(ip,ngt) = 0.
c           if ((ip.eq.3.or.ip.eq.10.or.ip.eq.13.or.ip.eq.14.
c     &        or.ip.eq.16).and.nyear.ne.1) then    
C             if (xlmax(ip).gt.1.5) suc_est(ip,ngt) = 0.
c              if (ylaimax_mean.gt.ylai_est) suc_est(ip,ngt) = 0. 
c           endif           
            
            Fgdd5(ip) = 1.
            if (gdd_est(ip) .gt. 0. .and. gdd5.lt.gdd_sup(ip)) then
             if (gdd5.lt.gdd_inf(ip)) then 
              Fgdd5(ip) = 0.
             else 
              Fgdd5(ip)=(1./2.)*(1.+erf(xk_erf*(gdd5-gdd_est(ip))
     &                   /(delta_gdd5*gdd_est(ip))))
             endif
            endif
            
            FTmmin(ip) = 1.
            if (Tmmin.gt.Tmmin_inf(ip)) then
             if (Tmmin.gt.Tmmin_sup(ip)) then 
              FTmmin(ip) = 0.
             else 
              FTmmin(ip)=(1./2.)*(1.-erf(xk_erf*(Tmmin-tcmax_est(ip))
     &                  /(delta_tmax)))
             endif
            endif
            
            Fwatmin(ip) = 1.
            if(watmax_est(ip).gt.0. .and. 
     &         watmin.gt.watmin_inf(ip)) then
             if (watmin.gt.watmin_sup(ip)) then 
              Fwatmin(ip) = 0.
             else 
              Fwatmin(ip)=(1./2.)*(1.-erf(xk_erf*(watmin-watmax_est(ip))
     &                   /(delta_watmax*watmax_est(ip))))
             endif
            endif
            
            if(nyr_t.eq.0.and.imig.eq.1.and.ip.eq.isp
!c           if(ip.eq.isp
     &       .and.irfg(ngt).ne.1) then    
     
              suc_est(ip,ngt) = 0.
             
            endif
            
         enddo


      else
         do ip = 1, npft
          if (frac(ip).le.1.e-7) then
            suc_est(ip,ngt) = 0.
          else
            suc_est(ip,ngt) = pgerm(ip)
          endif
          
            if(nyr_t.eq.0.and.imig.eq.1.and.ip.eq.isp
!c           if(ip.eq.isp
     &       .and.irfg(ngt).ne.1) then      
         
              suc_est(ip,ngt) = 0.
             
          endif
          
         enddo
      endif 

      return
      end subroutine pft_estab
