c=======================================================================
c***********************************************************************
      subroutine set_cpools(ngt)
c***********************************************************************
c=======================================================================
      implicit none
c=======================================================================
c   This routine reads initial value of carbon pools
c   and set them in the right form.
c=======================================================================
      include './com_18/parameter.common'
      include './com_18/angppf.common'      
      include './com_18/annee.common'
      include './com_18/annppf.common'      
      include './com_18/ecoin.common'
      include './com_18/init.common'
      include './com_18/inidata.common'
      include './com_18/nspc.common'
      include './com_18/plant_pool.common'
      include './com_18/plant_evol.common'
      include './com_18/prev_yr.common'
      include './com_18/soil_pool.common'

c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer , intent(in) :: ngt
      
      integer iday,ip,ipool,kpool
      
      real*4 val_min_rese
c-----------------------------------------------

c=======================================================================
c   initial value of carbon pools.
c=======================================================================

      do iday = 1, nd-1
         xhumus(iday)    = 0.
         do kpool = 1, 2
           xlit(kpool,iday) = 0.
         end do
         do ip = 1, npft
            do ipool = 1, npool
               carbon(ip,ipool,iday) = 0.
            enddo
         enddo
      enddo

      do kpool = 1, 2
       xlit(kpool,nd) = ylit_ini(kpool,ngt)
      end do

      xhumus(nd) = yhum_ini(ngt)

      do ip = 1, npft
          do ipool = 1, npool
            carbon(ip,ipool,nd) = ycar_ini(ip,ipool,ngt)
c            if(nyr_t.eq.0. .and. suc_est(ip,ngt).gt.1.e-5) then
            if(ip.le.npft0.or.ip.ge.npft0+ncrop+1.
     &and.frac(ip).gt.1.e-7) then
              if(carbon(ip,ipool,nd).le.0.)
     &           carbon(ip,ipool,nd) = carb_init(ip,ipool)

            endif
          enddo
	  
	  if(ip.gt.npft0.and.ip.le.npft0+ncrop) then
	    ygppf(ip) = ygppf_ini(ip,ngt)
	    ynppf(ip) = ynppf_ini(ip,ngt)
	  endif  

          rese(ip) = yrese_ini(ip,ngt)
c          if(nyr_t.eq.0. .and. suc_est(ip,ngt).gt.1.e-5) then
            val_min_rese = rese_frac(ip) * xip(ip,1) *
     &                (carbon(ip,2,nd)**xkappa(ip))
            if(rese(ip).lt.val_min_rese) rese(ip) = val_min_rese
c          endif
          ybinc_prv(ip) = ybinc_ini(ip,ngt)
      enddo

      if(nyr_t .eq. 0) then
         do ip = 1, npft
            if(suc_est(ip,ngt).le.1.e-5) then
               do ipool = 1, npool
                 carbon(ip,ipool,nd) = 0.
               enddo
               rese(ip) = 0.
	       ybinc_prv(ip) = 0.
            endif
         enddo
      endif


      return
      end subroutine set_cpools