
c=======================================================================
c***********************************************************************
      subroutine solar_flux
c***********************************************************************
c=======================================================================
      implicit none
c=======================================================================
c   calculation of the radiative transfer within the canopy.
c   clump_fac = clumping factor
c=======================================================================
      include './com_18/parameter.common'
      include './com_18/ext_con.common'
      include './com_18/loop.common'
      include './com_18/radcst.common'
      include './com_18/sol_in.common'
      include './com_18/strate.common'
      include './com_18/xvalues.common'

c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer ih
      
      real*4 atte,attedif,attedir1,attedir2
      real*4 facgk,facpk,facpkdif,fsun_toc
      real*4 gk,pk,pkdif,rhoc
      

c------------------------------------------------      
      do ih = 1,nh2

        attedir1 = 0.
        attedir2 = 0.
        attedif  = 0.
        fsun(ip,iday,ih) = 1.

        if(xmucar(iday,ih) .ne. 0.) then

          gk  = clump_fac * 0.5 / xmucar(iday,ih)
          facgk = - gk * xlai(ip,iday) / 2.
          if(facgk .lt. -40.) facgk = -40.

          fsun_toc   = 1.
          if(nstrate.eq.1) fsun_toc = fsun0(iday,ih)
          fsun(ip,iday,ih) = fsun_toc * exp(facgk)
          fsun(ip,iday,ih) = 0.01*int(0.49 + 100.*fsun(ip,iday,ih))
          if(fsun(ip,iday,ih).gt.1..or.fsun(ip,iday,ih).lt.0.) then
            write(61,*) 'error sun/shade',fsun(ip,iday,ih)
            stop
          endif 

          attedir1 = (1- ome) * gk
          pk    = facome * gk
          rhoc  = (2 / (1. + 1.6 *xmucar(iday,ih))) * rhoc0

          facpk = -pk    * xlai(ip,iday) / 2.
          if(facpk .lt. -40.) facpk = -40.
          atte  = exp(facpk) * pk * (1 - rhoc)
          attedir2 = (atte -  fsun(ip,iday,ih) * attedir1)
          if(attedir2.lt.0.) then
            attedir2 = 0.
            attedir1 = atte/fsun(ip,iday,ih)
          endif

          pkdif = 0.8 * facome
          facpkdif = -pkdif    * xlai(ip,iday) / 2.
          if(facpkdif .lt. -40.) facpkdif = -40.
          attedif  = exp(facpkdif) * pkdif * (1. - rhoc0)

        endif

        if(nstrate.eq.0) then
          apar(ip,iday,ih,1) = radun * 
     &                        ((attedir1+attedir2)*par0(iday,ih,1) 
     &                        + attedif*par0(iday,ih,2))
          apar(ip,iday,ih,2) = radun * 
     &          (attedir2*par0(iday,ih,1) + attedif*par0(iday,ih,2))
          apar(ip,iday,ih,3) = radun * attedif * par0(iday,ih,3)
        else
          apar(ip,iday,ih,1) = radun * 
     &                        ((attedir1+attedir2)*par1(iday,ih,1) 
     &                        + attedif*par1(iday,ih,2))
          apar(ip,iday,ih,2) = radun * 
     &          (attedir2*par1(iday,ih,1) + attedif*par1(iday,ih,2))
          apar(ip,iday,ih,3) = radun * attedif * par1(iday,ih,3)
        endif

      enddo

      return
      end subroutine solar_flux