c=======================================================================
c***********************************************************************
      subroutine initbdo
c***********************************************************************
c=======================================================================

c=======================================================================
c a difference between columns (j) and (j+1) of "tbldrv" corresponds
c to a back difference operation of order 1 on the derivatives between
c time = (norder-j)*stept and time = (norder-j-1)*stept;
c in the following k iterations,
c a difference between columns (j) and (j+1) of "deldrv" corresponds
c to a back difference operation of order k on the derivatives between
c time = (norder-j)*stept and time = (norder-j-1)*stept;
c
c for example, we have with norder = 4 :
c
c  --------+------------+------------+------------+----------------->
c          0.         stept       2.*stept     3.*stept             t
c
c       tbldrv(i,4)  tbldrv(i,3)  tbldrv(i,2)  tbldrv(i,1)=olddrv(i)
c
c  k=1 :   -         deldrv(i,3)  deldrv(i,2)  deldrv(i,1)=oldbdo(i,1)
c  k=2 :   -            -         deldrv(i,2)  deldrv(i,1)=oldbdo(i,2)
c  k=3 :   -            -            -         deldrv(i,1)=oldbdo(i,3)
c=======================================================================

c      implicit double precision (a-h,o-z)
      implicit none
      include './com_18/parameter.common'
      include './com_18/bkdf.common'
      include './com_18/coldrv.common'
      include './com_18/memory.common'
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer i,j,k
c
c-----------------------------------------------

      do j = 1, norder-1
         do i = 1, nequat
            deldrv(i,j) = tbldrv(i,j) - tbldrv(i,j+1)
         enddo
      enddo
      do i = 1, nequat
         oldbdo(i,1) = deldrv(i,1)
         olddrv(i)   = tbldrv(i,1)
      enddo

      do k = 2, norder-1
         do j = 1, norder-k
            do i = 1, nequat
               deldrv(i,j) = deldrv(i,j) - deldrv(i,j+1)
            enddo
         enddo
         do i = 1, nequat
            oldbdo(i,k) = deldrv(i,1)
         enddo
      enddo
      return
      end subroutine initbdo