c=======================================================================
c***********************************************************************
      subroutine tau(aa,bb,fnet,rdep,drk0,X0,XN,TAUI,NI)
c***********************************************************************
c=======================================================================

      implicit none
c      implicit double precision (a-h,o-z)
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer, intent(in) :: ni
      integer i,k,li

      real*8, intent(in) :: aa,bb,fnet,rdep,drk0,X0,XN
      real*8, intent(out) :: TAUI
      
      real*8  den,fac,fx,h,sum,x
c
c-----------------------------------------------
      LI=2*NI
      H=(XN-X0)/FLOAT(LI)
      SUM=0.
      DO I=0,LI
         K=2*INT((FLOAT(I)+0.01)/2.)
         IF(K.NE.I)THEN
            FAC=4.
         ELSEIF((I.EQ.0).OR.(I.EQ.LI))THEN
            FAC=1.
         ELSE
            FAC=2.
         ENDIF
         X=X0+FLOAT(I)*H
         den = fnet-drk0*dexp(aa+bb/x)
         if(dabs(den).gt.1.d-10)then
            fx = rdep/den
         else
            fx = rdep/1.d-10
         endif 
         SUM=SUM+FAC*FX
      enddo  
      TAUI=SUM*H/3.
      TAUI=dabs(TAUI)
      RETURN
      END subroutine tau

c=======================================================================
c***********************************************************************
      subroutine polfit(xi,yi,ni,aj,ndeg,err,cj,sl)
c***********************************************************************
c=======================================================================

c      implicit double precision (a-h,o-z)
      implicit none
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer, intent(in) :: ni,ndeg
      integer i,j,k,nc,ne
      
      real*8  differ,sum,xij,xik,yical,aj,err,sl,xi,yi,cj
c
c-----------------------------------------------
      
      dimension xi(ni),yi(ni),aj(0:ndeg),cj(ndeg+1),sl(ndeg+1,ndeg+2)
      ne=ndeg+1
      nc=ndeg+2
      do 100 k=1,ne
         sum=0.
         do 200 i=1,ni
            call puiss(xi(i),k-1,xik)
            sum=sum+xik*yi(i)
 200     continue
      sl(k,nc)=sum
 100  continue
      do 300 k=1,ne
         do 400 j=1,ne
            sum=0.
            do 500 i=1,ni
               call puiss(xi(i),k-1,xik)
               call puiss(xi(i),j-1,xij)
               sum=sum+xik*xij
 500        continue
         sl(k,j)=sum
 400     continue
 300  continue
      call gauss(ne,sl,cj)
      do 600 j=0,ndeg
         aj(j)=cj(j+1)
 600  continue
      err=0.
      do 700 i=1,ni
         yical=aj(0)
         do 800 j=1,ndeg
            call puiss(xi(i),j,xij)
            yical=yical+aj(j)*xij
 800     continue
      differ=yical-yi(i)
      err=err+differ*differ
 700  continue
      return
      end subroutine polfit
c=======================================================================
c***********************************************************************
      subroutine puiss(x,k,xk)
c***********************************************************************
c=======================================================================
    
c      implicit double precision (a-h,o-z)
      implicit none  
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer, intent(in) :: k
      integer :: i
         
      real*8, intent(in)  :: x
      real*8, intent(out) :: xk
c
c-----------------------------------------------
       
          xk=1.
          if(k.le.0)goto 200
          do 100 i=1,k
             xk=xk*x
 100  continue
          goto 400
 200  if(k.eq.0)goto 400
          do 300 i=1,-k
             xk=xk/x
 300  continue
 400  continue
      return
      end subroutine puiss
    
    
c=======================================================================
c***********************************************************************
      subroutine gauss(ne,sl,x)
c***********************************************************************
c=======================================================================
    
c      implicit double precision (a-h,o-z)
      implicit none        
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer, intent(in) :: ne
      integer jc,je,jr,nc
          
      real*8  coeff1,diag,rsum,sl,x
c
c-----------------------------------------------
          
      dimension sl(ne,ne+1),x(ne)
c=======================================================================
c   Subroutine Gauss solves a system of simultaneous linear algebraic
c   equations by Gaussian elimination and back substitution.
c   The number of equations (equal to the number of unknowns) is ne. 
c   The coefficients are in array sl(ne,ne+1), where the last 
c   column is the constants on the right sides of the equations. 
c   The answers are returned in the array x(ne).
c=======================================================================
      nc=ne+1
      do 100 je=1,ne
         diag=sl(je,je)
         if(diag.eq.0.)call exch(ne,nc,je,sl,diag)
         do 200 jc=je,nc
            sl(je,jc)=sl(je,jc)/diag
 200     continue
         do 300 jr=je+1,ne
            coeff1=sl(jr,je)
            do 400 jc=je,nc
               sl(jr,jc)=sl(jr,jc)-sl(je,jc)*coeff1
 400        continue
 300     continue
 100  continue
      x(ne)=sl(ne,nc)
      do 500 je=ne-1,1,-1
         rsum=0.
         do 600 jc=je+1,nc-1
            rsum=rsum+x(jc)*sl(je,jc)
 600     continue
         x(je)=sl(je,nc)-rsum
 500  continue
      return
      end subroutine gauss
          
    
    
c=======================================================================
c***********************************************************************
      subroutine init_c (y,ngt)
c***********************************************************************
c=======================================================================
c     implicit double precision (a-h,o-z)
      implicit none
      include './com_18/parameter.common'
      include './com_18/climin.common'
      include './com_18/coord.common'
      include './com_18/cstpi.common'
      include './com_18/cte.common'
      include './com_18/eco.common'
      include './com_18/inidata.common'
      include './com_18/monwat.common'
      include './com_18/varday.common'
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer idn,j,ngt
      real*8  y
c
c-----------------------------------------------
          
      dimension y(nequat)
    
c=====================================================================72
c     Initial values for every grid points and hydrological reservoirs 
c=====================================================================72
           do j=1,nres
            y(j) = ywat_ini(j,ngt)
           end do
           if (y(1).lt.0.) y(1)=0.
           if (y(2).lt.wpi) y(2)=wpi
           if (y(2).gt.fsi) y(2)=fsi
    
           do idn=1,nd
              aswday(idn)= (y(2)-wpi)/(fci-wpi)
           enddo
    
           aswmin = 999.
    
      return
      end subroutine init_c