c=======================================================================
c***********************************************************************
      subroutine dispersion
c***********************************************************************
c======================================================================= 
      use ifport
c  Propagation direction

c    1 = Sud-Ouest    
c    2 = Sud  
c    3 = Sud-Est
c    4 = Ouest
c    5 = Est
c    6 = Nord-Ouest
c    7 = Nord
c    8 = Nord-Est    
 
c      implicit double precision (a-h,o-z)
      implicit none
      
      include './com_18/parameter.common'
      include './com_18/annppf.common'
      include './com_18/coord.common'
      include './com_18/cstpi.common'
      include './com_18/cte.common'
      include './com_18/disper.common'
      include './com_18/ecoin.common'
      include './com_18/griddata.common'
      include './com_18/input_par.common'
      include './com_18/inidata.common'
      include './com_18/kernel.common'
      include './com_18/nspc.common'
      include './com_18/solpar.common'
c-----------------------------------------------
c JLP ajout� pour implicit none
c
      real*4  xde0st
c
c-----------------------------------------------
      
      double precision xlg1,xlt1,xlg2,xlt2,distan
      integer i,j,k,l,ip,ngt,ngt1,ngt2
      integer ngt_temp1,ngt_temp2,nint,nitmax,imeth,num,nshot
      real*4 rayon,rad,deg,delta_phi,delta_lambda,xa,xb,R_compet,
     &       diag,ermax,erfi,sig,mu,xdest,ydest,z
c JLP      real*4 seed
      real*4 new_seed
      real*4 frnd,rand1,rand2,dir_rand,dist_rand,delta1
      real*4 xlo_min,xlo_max,xla_min,xla_max,
     &       xlo_min2,xlo_max2,xla_min2,xla_max2
      real*8 x,fx
      
      
      if(isp.eq.6) ynppf_max = 450.
      if(isp.eq.8) ynppf_max = 450.
      
      do ngt = 1, n_pix
       ylongi = xlg(ngt)
       ylati = xlt(ngt)
       do ip = 1, npft
        ynppf(ip)=ynppf_grd(ip,ngt)
       end do     
      
       ynppf_mean = 0.
      
       do ip = 1,npft
        if(ip.ne.1) ynppf_mean = ynppf_mean + 
     &                       yfrac_ini(ip,ngt)*ynppf(ip)
       enddo
               
       ngt_temp1 = 0
       ngt_temp2 = 0   

       rayon = rearth*1000. ! (en m)
         
       rad = pi/180.
       deg = 180./pi
             
       delta_phi = (rayon*rad*declat) !/2. MARIE
       delta_lambda = (rayon*cos(rad*ylati)*(rad*declg)) !/2. MARIE  
       diag = ((delta_phi*delta_phi)+(delta_lambda*delta_lambda))**0.5 ! MARIE     
                    
       do ip = 1, npft0
      
        if(ip.eq.isp) then
      
         if(ynppf(ip).ge.ynppf_max) ynppf(ip) = ynppf_max
         spec_npp = ynppf(ip)*yfrac_ini(ip,ngt)
        
         if(spec_npp.ne.0.) then
        
          if(isp.eq.6) Xmax = 65.*mig_rate(ip,ngt)
          if(isp.eq.8) Xmax = 45.*mig_rate(ip,ngt)
          Xmin = 0. 
         
          xa = Xmax 
          xb = Xmin
          nint = 5
          x = Xmax 
          ermax = 1.e-25 !1.e-9
          nitmax = 100
          imeth = 0   
          
          call nonlineq2(xa,xb,nint,x,fx,ermax,nitmax,imeth,num,ngt) ! ermsax dans fagus???
c         if(ngt.eq.3463) write(*,*) 'Number of iterations:',num
c         if(ngt.eq.3463) write(*,*) 'x = ',x,'  f(x) = ',fx  
          
          if(x.eq.-999999.) then
c          if(ngt.eq.3463) write(*,*) 'iter2'
          nint = 125
          x = Xmax
      call nonlineq2(xa,xb,nint,x,fx,ermax,nitmax,imeth,num,ngt)    
      else
        go to 900                   
      endif  
      
      if(x.eq.-999999.) then
c        if(ngt.eq.3463) write(*,*) 'iter3'
        nint = 1250
        x = Xmax
      call nonlineq2(xa,xb,nint,x,fx,ermax,nitmax,imeth,num,ngt)    
      else
        go to 900                   
      endif 
          
      if(x.eq.-999999.) then
        mig_rate(ip,ngt) = 0.
c       if(ngt.eq.3463) write(*,*) 'iter4'
        go to 800
      endif
                  
 900     continue 
                  
          R_compet = x/Xmax     
      
          mig_rate(ip,ngt) = R_compet*mig_rate(ip,ngt)
        
        else
        
         mig_rate(ip,ngt) = 0.
        
        endif
        
 800    continue
      
c=======================================================================         
c    short-distance dispersal
c=======================================================================      
          
        if(pres(ip,ngt).eq.1) pres_new(ip,ngt) = 1
          
        do k = 1, n_nghmx
          if(pres_side(ip,k,ngt).eq.1) then     
            if(prop(ip,k,ngt).lt.diag) then  !90000.
              prop(ip,k,ngt)= prop(ip,k,ngt)
     &                        +mig_rate(ip,ngt) 
            endif
            preside_new(ip,k,ngt) = 1
          endif 
        enddo   
                
        if(suc_est(ip,ngt).ne.0.
     &        .and.mig_rate(ip,ngt).ne.0.) then
        
          do k = 1, n_nghmx
            ngt1 = neighbor(k,ngt)
            l = 9-k     
                        
            if(pres_side(ip,k,ngt).eq.0) then   
                        
              if(ngt1.eq.0) then
                go to 100
              endif     
                            
              if(pres_side(ip,l,ngt1).eq.1) then
                prop(ip,k,ngt) = mig_rate(ip,ngt)
                pres_new(ip,ngt) = 1
                preside_new(ip,k,ngt) = 1
                go to 700
              endif             
                  
 100          continue
 
              if(k.eq.1) then
                ngt_temp1 = neighbor(2,ngt)
                if(ngt_temp1.eq.0) then 
                  go to 200 
                endif   
                if(pres_side(ip,6,ngt_temp1).eq.1) then
                  prop(ip,k,ngt) = mig_rate(ip,ngt)
                  pres_new(ip,ngt) = 1
                  preside_new(ip,k,ngt) = 1
                  go to 700
                endif
 200            continue                      
                ngt_temp2 = neighbor(4,ngt)
                if(ngt_temp2.eq.0) then
                  go to 700 
                endif   
                if(pres_side(ip,3,ngt_temp2).eq.1) then
                  prop(ip,k,ngt) = mig_rate(ip,ngt)
                  pres_new(ip,ngt) = 1
                  preside_new(ip,k,ngt) = 1
                  go to 700
                endif
              endif
                    
              if(k.eq.3) then
                ngt_temp1 = neighbor(2,ngt)
                if(ngt_temp1.eq.0) then
                  go to 300 
                endif   
                if(pres_side(ip,8,ngt_temp1).eq.1) then
                  prop(ip,k,ngt) = mig_rate(ip,ngt)
                  pres_new(ip,ngt) = 1
                  preside_new(ip,k,ngt) = 1
                  go to 700
                endif
 300            continue                      
                ngt_temp2 = neighbor(5,ngt)
                if(ngt_temp2.eq.0) then
                  go to 700 
                endif           
                if(pres_side(ip,1,ngt_temp2).eq.1) then
                  prop(ip,k,ngt) = mig_rate(ip,ngt)
                  pres_new(ip,ngt) = 1
                  preside_new(ip,k,ngt) = 1
                  go to 700
                endif
              endif
                    
              if(k.eq.6) then
                ngt_temp1 = neighbor(4,ngt)
                if(ngt_temp1.eq.0) then
                  go to 400 
                endif   
                if(pres_side(ip,8,ngt_temp1).eq.1) then
                  prop(ip,k,ngt) = mig_rate(ip,ngt)
                  pres_new(ip,ngt) = 1
                  preside_new(ip,k,ngt) = 1
                  go to 700
                endif
 400            continue                      
                ngt_temp2 = neighbor(7,ngt)
                if(ngt_temp2.eq.0) then
                  go to 700 
                endif
                if(pres_side(ip,1,ngt_temp2).eq.1) then
                  prop(ip,k,ngt) = mig_rate(ip,ngt)
                  pres_new(ip,ngt) = 1
                  preside_new(ip,k,ngt) = 1
                  go to 700
                endif
              endif
                    
              if(k.eq.8) then
                ngt_temp1 = neighbor(5,ngt)
                if(ngt_temp1.eq.0) then
                  go to 500 
                endif   
                if(pres_side(ip,6,ngt_temp1).eq.1) then
                  prop(ip,k,ngt) = mig_rate(ip,ngt)
                  pres_new(ip,ngt) = 1
                  preside_new(ip,k,ngt) = 1
                  go to 700
                endif
 500            continue                      
                ngt_temp2 = neighbor(7,ngt)
                if(ngt_temp2.eq.0) then
                  go to 700 
                endif
                if(pres_side(ip,3,ngt_temp2).eq.1) then
                  prop(ip,k,ngt) = mig_rate(ip,ngt)
                  pres_new(ip,ngt) = 1
                  preside_new(ip,k,ngt) = 1
                  go to 700
                endif
              endif 
                                         
            endif
 700        continue 
          enddo          
        endif   
               
        do k = 1, n_nghmx
               
c         yphi0 = ylat(k,ngt)
c         ylamda0 = ylon(k,ngt)
          xlt1 = ylat(k,ngt)
          xlg1 = ylon(k,ngt)
               
          if(preside_new(ip,k,ngt).eq.1) then
                
            if(prop(ip,k,ngt).gt.0..and.
     &         prop(ip,k,ngt).le.diag) then !90000.
     
              count(ip,k,ngt) = count(ip,k,ngt) + 1 ! MARIE
      
              do j = 1, n_nghmx
                
c cos(alpha) = sin(phi0)*sin(phi)+cos(phi0)*cos(phi)*cos(delta_lambda)
c avec alpha = longueur de l'arc de grand cercle s�parant les 2 points
c et phi et phi0 les latitudes des 2 points

c               delta_lon = abs(ylon(j,ngt)-ylamda0) 
c                dist(k,j) = rayon*acos(sin(rad*yphi0)
c     &                      *sin(rad*ylat(j,ngt))
c     &                      +cos(rad*yphi0)*cos(rad*ylat(j,ngt))
c     &                       *cos(rad*delta_lon))  
                
                xlt2 = ylat(j,ngt)
                xlg2 = ylon(j,ngt)
                call distance(xlg1,xlt1,xlg2,xlt2,distan)
                dist(k,j)=distan*1000.
       
                if(prop(ip,k,ngt).ge.dist(k,j)) then 
                  preside_new(ip,j,ngt) = 1
                endif    
              enddo   
            
            endif
            
            if(prop(ip,k,ngt).le.diag) 
     &               prop_time(ip,k,ngt) = count(ip,k,ngt) ! MARIE
c           write(*,*) ngt,prop(ip,k,ngt)
          endif                 
        enddo
        
c       write(*,'(2(1x,f8.3),8(1x,f12.3),8(1x,i10))') 
c     &          ylongi,ylati,(prop(ip,k,ngt),k=1,n_nghmx),
c     &                     (prop_time(ip,k,ngt),k=1,n_nghmx) ! MARIE
c        write(*,*) isp,n_nghmx 

c=======================================================================         
c    long-distance dispersal
c=======================================================================

c    nombre de tirs proportionels � la npp

        if(ip.eq.21.or.ip.eq.27.or.ip.eq.29) then

          if(pres(ip,ngt).eq.1) then
          
            nshot = 10

            do i = 1, nshot
              
              new_seed = 1.26*nyear + ngt*0.47 + i              
              call randnum(new_seed,frnd) 
              rand1 = frnd
c             rand1 = rand(0.)*(0.+1.)  !direction = azimuth de ce grand cercle par rapport au m�ridien de la source

              new_seed = rand(0)*(0.+i)*new_seed
              call randnum(new_seed,frnd)
              rand2 = frnd
c             rand2 = rand(0.)*(0.+1.) !distance = longueur de l'arc de grand cercle s�parant les 2 points
              
c   Wind normal distribution
c   Cumulative distribution function: 1./2. * (1. + erf((x-mu)/(sig*(2.)**0.5)))              
                
              z = 2.*rand1-1.
              erfi = 1./2.*(pi)**0.5*(z+1./12.*pi*(z)**3.
     &                 +7./480.*(pi)**2.*(z)**5.
     &                 +127./40320.*(pi)**3.*(z)**7.
     &                 +4369./5806080.*(pi)**4.*(z)**9.
     &                 +34807./182476800.*(pi)**5.*(z)**11.)   
                      
              dir_rand = 87.837*(2.)**0.5*erfi+90.
              if(dir_rand.ge.360.) dir_rand = dir_rand-360.
              if(dir_rand.lt.0.) dir_rand = dir_rand+360.

c    Fagus dispersal kernel: log-normal distribution
c    Cumulative distribution function: 1./2. + 1./2. * erf((ln(x) - mu)/((2.*(sig)**2.)**0.5))
              
        sig = 2.9
        mu = 5.1        

cWC         if(probd .le. 0.5) then 
cWC         sig=0.02   !0.375 !0.61   !3.121
cWC         mu=2.7
cWC         elseif(probd .gt. 0.5) then
cWC         sig=0.375
cWC         mu=2.7
cWC         endif       
        
        
        z = 2.*(rand2-1./2.)
        erfi = 1./2.*(pi)**0.5*(z+1./12.*pi*(z)**3.
     &                 +7./480.*(pi)**2.*(z)**5.
     &                 +127./40320.*(pi)**3.*(z)**7.
     &                 +4369./5806080.*(pi)**4.*(z)**9.
     &                 +34807./182476800.*(pi)**5.*(z)**11.) 
     
       dist_rand = exp((2.*(sig)**2.)**0.5*erfi+mu)
cWC       dist_rand=10**((sig)*(2**0.5)*erfi+mu)
              
c    Exponentielle d�croissante
c        y = y0*exp(-x/tau) avec tau = dur�e de vie         
c        y = a.exp(bt)+c 
c        t = 1/b * log((y-c)/a)
              
c             tau = 1./1. !4000.
           
c             dist_rand = -1./tau*log(-(rand2-1.))
c              dist_rand = dist_rand/rayon !radians
c             dist_rand = (180.*(dist_rand/r))/pi !degr�s             

              ydest = deg
c     &        *(dasin(sin((pi*xla)/180.)*cos((pi*dist_rand)/180.)   
     &            *(asin(sin(rad*ylati)*cos(dist_rand)
c     &        + cos((pi*xla)/180.)*sin((pi*dist_rand)/180.)     
     &            + cos(rad*ylati)*sin(dist_rand)
     &            * cos(rad*dir_rand)))
              xdest = ylongi
     &            +deg
     &            *(acos((cos(dist_rand)-sin(rad*ylati)
     &            *sin(rad*ydest))/(cos(rad*ylati)*cos(rad*ydest))))

cc              dist_rand = rayon*dist_rand
                
              if(dir_rand.le.45.or.dir_rand.ge.315) then               
                delta1 = delta_phi           
              elseif(dir_rand.ge.45.and.dir_rand.le.135) then
                delta1 = delta_lambda            
              elseif(dir_rand.ge.135.and.dir_rand.le.225) then
                delta1 = delta_phi 
              elseif(dir_rand.ge.225.and.dir_rand.le.315) then     
                delta1 = delta_lambda 
              endif

              if(dist_rand.ge.delta1) then !ou distance qu'il reste � parcourir
             
                do ngt2 = 1, n_pix
            
                  xlo_min = xlg(ngt2)-(declg/2.)
                  xlo_max = xlg(ngt2)+(declg/2.)
                  xla_min = xlt(ngt2)-(declat/2.)
                  xla_max = xlt(ngt2)+(declat/2.)
               
                  xlo_min2 = xlg(ngt2)-(declg/4.)
                  xlo_max2 = xlg(ngt2)+(declg/4.)
                  xla_min2 = xlt(ngt2)-(declat/4.)
                  xla_max2 = xlt(ngt2)+(declat/4.)       
             
                  if(xdest.ge.xlo_min.and.xdest.le.xlo_max.and.
     &               ydest.ge.xla_min.and.ydest.le.xla_max) then 
                     
                    if(suc_est(ip,ngt2).gt.1.e-5) then
                      pres_new(ip,ngt2) = 1
                      if(xdest.ge.xlo_min.and.xdest.le.xlo_min2.and.
     &                 ydest.ge.xla_min.and.ydest.le.xla_min2.and.
     &                 prop(ip,1,ngt2).eq.0) then
                        prop(ip,1,ngt2) = mig_rate(ip,ngt2)
                        preside_new(ip,1,ngt2) = 1
                      endif  
                      if(xdest.ge.xlo_min2.and.xdest.le.xlo_max2.and.
     &                 ydest.ge.xla_min.and.ydest.le.xla_min2.and.
     &                 prop(ip,2,ngt2).eq.0) then                               
                        prop(ip,2,ngt2) = mig_rate(ip,ngt2)
                        preside_new(ip,2,ngt2) = 1
                      endif  
                      if(xdest.ge.xlo_max2.and.xdest.le.xlo_max.and.
     &                 ydest.ge.xla_min.and.ydest.le.xla_min2.and.
     &                 prop(ip,3,ngt2).eq.0) then                        
                        prop(ip,3,ngt2) = mig_rate(ip,ngt2)
                        preside_new(ip,3,ngt2) = 1
                      endif  
                      if(xdest.ge.xlo_min.and.xdest.le.xlg(ngt2).and.
     &                 ydest.ge.xla_min2.and.ydest.le.xla_max2.and.
     &                 prop(ip,4,ngt2).eq.0) then                        
                        prop(ip,4,ngt2) = mig_rate(ip,ngt2)
                        preside_new(ip,4,ngt2) = 1
                      endif  
                      if(xdest.ge.xlg(ngt2).and.xdest.le.xlo_max.and.
     &                 ydest.ge.xla_min2.and.ydest.le.xla_max2.and.
     &                 prop(ip,5,ngt2).eq.0) then                        
                        prop(ip,5,ngt2) = mig_rate(ip,ngt2)
                        preside_new(ip,5,ngt2) = 1
                      endif  
                      if(xdest.ge.xlo_min.and.xdest.le.xlo_min2.and.
     &                 ydest.ge.xla_max2.and.ydest.le.xla_max.and.
     &                 prop(ip,6,ngt2).eq.0) then                        
                        prop(ip,6,ngt2) = mig_rate(ip,ngt2)
                        preside_new(ip,6,ngt2) = 1
                      endif  
                      if(xde0st.ge.xlo_min2.and.xdest.le.xlo_max2.and.
     &                 ydest.ge.xla_max2.and.ydest.le.xla_max.and.
     &                 prop(ip,7,ngt2).eq.0) then                        
                        prop(ip,7,ngt2) = mig_rate(ip,ngt2)
                        preside_new(ip,7,ngt2) = 1
                      endif  
                      if(xdest.ge.xlo_max2.and.xdest.le.xlo_max.and.
     &                 ydest.ge.xla_max2.and.ydest.le.xla_max.and.
     &                 prop(ip,8,ngt2).eq.0) then                        
                        prop(ip,8,ngt2) = mig_rate(ip,ngt2)     
                        preside_new(ip,8,ngt2) = 1
                      endif
                    endif 
                    go to 600   
                  endif   
                enddo
             
 600            continue
                 
              endif
                   
            enddo
               
          endif
              
        endif  
                  
c=======================================================================        
      endif
            
      enddo
      enddo
        
      return
      end subroutine dispersion