c=======================================================================
c***********************************************************************
      subroutine new_frac2
c***********************************************************************
c======================================================================= 
c      implicit double precision (a-h,o-z)
      implicit none 
      
      include './com_18/parameter.common'
      include './com_18/annee.common'
      include './com_18/annppf.common'
      include './com_18/burned.common'
      include './com_18/coord.common' 
      include './com_18/cte.common'
      include './com_18/disper.common'
      include './com_18/ecoin.common'
      include './com_18/estab.common'
      include './com_18/files_car.common'
      include './com_18/frac_change.common'
      include './com_18/gddpix.common'
      include './com_18/griddata.common'
      include './com_18/inidata.common'
      include './com_18/init.common'
      include './com_18/input_par.common'
      include './com_18/landuse.common'      
      include './com_18/mort.common'
      include './com_18/npp.common'
      include './com_18/nspc.common'
      include './com_18/pho_sch.common'
      include './com_18/plheight.common'
      include './com_18/tresh.common'
c-----------------------------------------------
c JLP ajout� pour implicit none
c
      real*4  aaa,bbb
c
c-----------------------------------------------
      
      character*50 title,pft_name(nplant)
      character*132 sdata
      character*100 formatw
      integer k,ip,ngt,ipft
      real*4 herb_seed,tree_seed
 
c=======================================================================
c   reads PFT tolerance parameters
c=======================================================================
      open(14,file=filebagtol)
      read(14,*)title
      do ip = 1, npft
       read(14,125) pft_name(ip),sdata
       read(sdata,*)ipft,ic4(ip),idec(ip),ttreshi1(ip),
     &        ttreshi2(ip),ttresha1(ip),ttresha2(ip),
     &        wattresh1(ip),wattresh2(ip),xpar_tresh1(ip),
     &        xpar_tresh2(ip),gdd_est(ip),tcmax_est(ip),
     &        watmax_est(ip),pgerm(ip),bag_h(ip)
      enddo

125   format(a50,a132)
      close(14)

c=======================================================================
c   reads initial values of carbon pools
c=======================================================================
      open(19,file=filecinit)
      read(19,*)title
      do ip = 1, npft
         read(19,126) pft_name(ip),sdata
         read(sdata,*)(carb_init(ip,k),k=1,npool)
      enddo
      
126   format(a50,a70)  
      close(19)

      do ngt = 1, n_pix
        ylongi = xlg(ngt)
        ylati = xlt(ngt)
        do ip = 1, npft
         ynppf(ip)=ynppf_grd(ip,ngt)
        end do             
        
        read(83,*)aaa,bbb,yfnoburn             
        read(86,*)aaa,bbb,(ftot(ip),ip=1,npft)
         
        read(87,*)aaa,bbb,(Fgdd5(ip),ip=1,npft)
        read(88,*)aaa,bbb,(FTmmin(ip),ip=1,npft)        
        read(89,*)aaa,bbb,(Fwatmin(ip),ip=1,npft)
      
c=======================================================================
c     initialization
c=======================================================================      
      
        hole_herb = 0.
        hole_tree = 0.
        strat_herb = 0.
        strat_tree = 0.
        stratnew1 = 0.
        stratnew2 = 0.
       
        do ip = 1, npft0  
       
         frac(ip) = yfrac_ini(ip,ngt)   
          
         if(ip.le.nherb+nbush) then
          strat_herb = strat_herb + frac(ip)
         else
          strat_tree = strat_tree + frac(ip)
         endif  

        enddo       
      
c=======================================================================
c     loss fraction
c=======================================================================        

       do ip = 1, npft0
              
        fracnew(ip) = ftot(ip)*frac(ip) 
               
       enddo
      
       do ip = 1, nherb+nbush
         stratnew1 = stratnew1 + fracnew(ip)
       enddo
      
       do ip = 1+nherb+nbush, npft0
         stratnew2 = stratnew2 + fracnew(ip)
       enddo
      
       do ip = 1, npft0
         perte(ip) = frac(ip)-fracnew(ip)
       enddo 

      
c      hole_herb = strat_herb-stratnew1
      hole_herb = frac_nat(ngt)-stratnew1
      if(hole_herb.lt.0.) hole_herb = 0.

c      hole_tree = strat_tree-stratnew2
      hole_tree = frac_nat(ngt)-stratnew2
      if(hole_tree.lt.0.) hole_tree = 0.
      
c=======================================================================
c     seed production
c=======================================================================
      
      do ip = 1, npft0              
        seed_prod(ip)  = 0.
        seed_estab(ip) = 0.
        dispin(ip)     = 0.
        dispout(ip)    = 0.
        frac_seed(ip)  = 0.
        density(ip)    = 0.
        if(suc_est(ip,ngt).gt.1.e-5) then
          density(ip) = 1.
          dispin(ip) = carb_init(ip,2)
          if(ip.ne.isp) pres_new(ip,ngt) = 1
          if(ip.eq.isp.and.pres_new(ip,ngt).eq.0) then
            density(ip) = 0.
            dispin(ip) = 0.
          endif
        endif

      end do

      do ip = 1, npft0

        seed_prod(ip) = 
     &          Fgdd5(ip)*frac(ip)*ynppf(ip)+dispin(ip)-dispout(ip)
        seed_estab(ip) = 
     &                  FTmmin(ip)*Fwatmin(ip)*pgerm(ip)*seed_prod(ip)

      enddo  
      
      herb_seed = 0.
      tree_seed = 0.
      do ip = 1, nherb+nbush
        herb_seed = herb_seed + density(ip)*seed_estab(ip)
      enddo
      
      do ip = nherb+nbush+1, npft0
        tree_seed = tree_seed + density(ip)*seed_estab(ip)
      enddo
      
      if(herb_seed.gt.0.) then
        do ip = 1, nherb+nbush
          frac_seed(ip) = hole_herb
     &                         *(density(ip)*seed_estab(ip)/herb_seed)  
        enddo
      endif
      
      if(tree_seed.gt.0.) then
        do ip = nherb+nbush+1, npft0
          frac_seed(ip) = hole_tree
     &                   *(density(ip)*seed_estab(ip)/tree_seed)
        enddo
      endif
      
      do ip = 1, npft0
        frac(ip) = fracnew(ip) + frac_seed(ip)  
      enddo
     
c=======================================================================
c     write migration
c=======================================================================      

        do ip = 1, npft0
          pres(ip,ngt) = pres_new(ip,ngt) 
          yfrac_ini(ip,ngt) = frac(ip)
        enddo 
        write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,i1))' 
        write(78,formatw) 
     &          ylongi,ylati,(pres(ip,ngt),ip=1,npft0)
        do ip = 1, npft0
          do k = 1, n_nghmx
            pres_side(ip,k,ngt) = preside_new(ip,k,ngt)
          enddo  
          if(ip.eq.isp) then
            write(76,'(2(1x,f8.3),8(1x,f12.3),8(1x,i10))') 
     &           ylongi,ylati,(prop(ip,k,ngt),k=1,n_nghmx),
     &                     (prop_time(ip,k,ngt),k=1,n_nghmx) ! MARIE
            write(77,'(2(1x,f8.3),8(1x,i6))') 
     &           ylongi,ylati,(pres_side(ip,k,ngt),k=1,n_nghmx)
          endif
        enddo
 
        write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f10.8))'
        write(60,formatw) ylongi,ylati,(frac(ip),ip=1,npft)     
      
      enddo

      return
      end subroutine new_frac2