c=======================================================================
c***********************************************************************
      subroutine itochar2(i,ch)
c***********************************************************************
c=======================================================================

c=======================================================================
c   Subroutine to convert an integer into a character
c=======================================================================
      implicit none

      include './com_18/parameter.common'
      real r
      integer i,k
      character*2 ch
      r=i/10.0
      k=r
      ch=char(k+48)//char(i-10*k+48)

      return
      end subroutine itochar2


c=======================================================================
c***********************************************************************
      subroutine givnletters(z,nlet)
c***********************************************************************
c=======================================================================

c=======================================================================
c   Subroutine for counting the number of letters in a character*8 
c   variable
c=======================================================================
      implicit none
      include './com_18/parameter.common'
      integer nlet
      character*8 z,zzone

      zzone=z
      nlet=1
52    continue
      if (zzone(nlet:nlet).ne.' ') then
            nlet=nlet+1
            if (nlet.le.8) goto 52
      endif
        nlet=nlet-1 

      return
      end subroutine givnletters


c=======================================================================
c***********************************************************************
      subroutine charlen(name,kn)
c***********************************************************************
c=======================================================================

c=======================================================================
c   Subroutine for counting the number of letters in a character*80 
c   variable
c=======================================================================
      implicit none
      integer kn
      character*120 name
      kn = 0
    1 continue
      kn = kn + 1
      if(name(kn:kn) .ne. ' ') goto 1
      kn = kn - 1
      return 
      end subroutine charlen


c=======================================================================
c*********************************************************************** 
      subroutine distance(xlg1,xlt1,xlg2,xlt2,distan)
c***********************************************************************
c=======================================================================
          
      implicit none
      include './com_18/parameter.common'      
      include './com_18/solpar.common'
      include './com_18/cstpi.common'  
      double precision xlg1,xlt1,xlg2,xlt2,distan
      double precision c1,c2,s1,s2,cdlg,argum    
c 
c   xlg1,xlt1 = long, lat of first point (deg)
c   xlg2,xlt2 = long, lat of second point (deg)
c   rearth = Earth radius (km) - in solpar.common 
c   distan = distance (km)

c       pi180 = 3.1415926535/180.  - in common cstpi
      c1 = dcos(xlt1*pi180)
      c2 = dcos(xlt2*pi180)
      s1 = dsin(xlt1*pi180)
      s2 = dsin(xlt2*pi180)       
      cdlg = dcos((xlg2-xlg1)*pi180)       
      argum = s1*s2+c1*c2*cdlg       
      if (argum.le.-0.9999999999999d+0) argum = -0.9999999999999d+0 
      if (argum.ge. 0.9999999999999d+0) argum =  0.9999999999999d+0 
      distan = rearth*dacos(argum)
        
      return
      end subroutine distance