c=======================================================================
c***********************************************************************
      subroutine zone2(reg,region)
c***********************************************************************
c=======================================================================
c  Determines region from reg
c  reg is a climate zone (A, B, C, D. E)
c  region is a geographical area (A1, A2, A3, A4, 
c                                 B1, B2, B3, B4, B5, B6, 
c                                 C1, C2, C3, C4, C5, C6, 
c                                 D1, D2, D3, 
c                                 E1, E2, E3, E4) 
c ======================================================================
      implicit none
      include './com_18/parameter.common'
      include './com_18/coord.common'
c-----------------------------------------------
c JLP ajout� pour implicit none
c
      real*4  a,b,x,y
c
c-----------------------------------------------      
      character*1 reg
      character*2 region

      x = ylongi
      y = ylati
      if(reg .eq. 'A') then
         if(x .lt. -30.) then
            region = 'A1'
         elseif(x .lt. 60.) then
            region = 'A2'
         elseif(y .gt. -10.5) then
            region = 'A3'
         else
            region = 'A4'
         endif
         return
      endif

      if(reg .eq. 'B') then
         if(y .lt. -3.7) then
            if(x .lt. -30.) then
               region = 'B4'
            elseif(x .lt. 60.) then
               region = 'B5'
            else
               region = 'B6'
            endif
         elseif(x .lt. -30.) then
            region = 'B1'
         elseif(y .lt. 22.5) then
            if(x .lt. 60.) then
               region = 'B2'
            else
               region = 'B3'
            endif
         elseif(y .lt. 28.5) then
            if(x .le. 51.) then
               region = 'B2'
            else 
               a = (28.5 - 22.5)/(51. - 60.)
               b = 28.5 - 51.*a
               if(y .lt. (a*x+b)) then
                  region = 'B2'
               else
                  region = 'B3'
               endif
            endif
         else
            if(x .le. 25.) then
               region = 'B2'
            else 
               a = (90. - 28.5)/(25. - 51.)
               b = 90. - 25.*a
               if(y .lt. (a*x+b)) then
                  region = 'B2'
               else
                  region = 'B3'
               endif
            endif
         endif
      return
      endif

      if(reg .eq. 'C') then
         if(x .lt. -30.) then
            if(y .gt. 12.) then
               region = 'C1'
            else
               region = 'C4'
            endif
         elseif(x .lt. 60.) then
            if(y .gt. 18.) then
               region = 'C2'
            else
               region = 'C5'
            endif
         elseif(y .gt. 0.) then
               region = 'C3'
         else
               region = 'C6'
         endif
         return
      endif

      if(reg .eq. 'D') then
         if(x .lt. -30.) then
            region = 'D1'
         elseif(x .lt. 60.) then
            region = 'D2'
         else
            region = 'D3'
         endif
         return
      endif

      if(reg .eq. 'E') then
         if(x .lt. 0.) then
            if(y .gt. 0.) then
               region = 'E1'
            else
               region = 'E4'
            endif
         elseif(x .lt. 50.) then
               region = 'E2'
         else
               region = 'E3'
         endif
         return
      endif


      end subroutine zone2