      subroutine caraib
c// Fichier caraib_netcdf_02.F du jeudi 18 d�cembre 2014, 11:51:02 (UTC+0100)
c//  - completed enhanced NetCDF
c// Fichier caraib_netcdf_01.F du mercredi 17 d�cembre 2014, 08:19:43 (UTC+0100)
c//  - Corrected a few Fortran non-conformities ("name="; "rand(0.)")
c//  - Also corrected declaration in common/disper.common
c//  - Further added more verbose HANDLE_NCERRORS to mod_netcdfcaraib
c//
c// Fichier caraib_netcdf_00.f du mardi 16 d�cembre 2014, 16:05:38 (UTC+0100)
c//  - Initial NetCDF version
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c    CCCC       AA  RRRAR    AA        II   BBB
c   CC         AAA  R   RA   AAA       II   B  BB
c  CC         A AA  R  RR    AA A      II   B  BB
c  CC        AAAAA  RRRR     AAAAA     II   BBB
c  CC       A   AA  R  RA    AA   A    II   B  BB
c   CC     A    AA  R   RA   AA    A   II   B  BB
c    CCCC A     AA  R    RA  AA     A  II   BBBB
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   CARAIB: CARbon Assimilation In the Biosphere
c   A global vegetation model
c   contact:  francois@astro.ulg.ac.be
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc72
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc72
c         II         BBBBBB         MM     MM
c         II         BB   BB        MMM   MMM
c         II         BB   BB        MMMM MMMM 
c         II         BBBBBB         MM MMM MM
c         II         BB   BB        MM  M  MM
c         II         BB   BB        MM     MM
c         II         BBBBBB         MM     MM
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc72
c   IBM: Improved Bucket Model
c   A global soil hydrological model
c   written by : L. Francois, B. Hubert
c   contact:  francois@astro.ulg.ac.be
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc72
c
c !!! CAUTION-CAUTION-CAUTION-CAUTION-CAUTION-CAUTION-CAUTION !!!
c
c   CAUTION: maximum number of pixels : ngrid = 100000
c            maximum number of vegetation types : nplant = 40
c
c     if larger values of these parameters are to be used,
c     they should be changed in the parameter line
c       ('parameter.common' file)
c
c=====================================================================72
      USE MOD_NETCDFCARAIB
      IMPLICIT NONE

c// BEGIN
      CHARACTER(LEN=*), PARAMETER :: fn_caraib = __FILE__
c
      INTEGER :: istatusn
                      ! Starting indices and counters for NetCDF reads
      INTEGER, DIMENSION(3), SAVE :: istart = 0, ncount = 0      
c                     ! Starting indices and counters for NetCDF reads
      INTEGER, DIMENSION(3), SAVE :: istartn = 0, ncountn = 0
c                     ! Temporary indices for searching purposes
      INTEGER :: ncpos_lon_saven, ncpos_lat_saven, ntimedata

c// END
c-----------------------------------------------
c JLP ajout� pour implicit none
c
      integer i,i_pix,igrr,ipr,iprint,istatus,iy,k,m,niter,ny0
      real*4  dn,xxx,yyy
c
c-----------------------------------------------

      include './com_18/parameter.common'
      include './com_18/griddata.common'
      include './com_18/annee.common'
      include './com_18/burned.common'      
      include './com_18/climin0.common'
      include './com_18/climin.common'
      include './com_18/climkop.common'      
      include './com_18/coord.common'
      include './com_18/cstpi.common'
      include './com_18/cte.common'
      include './com_18/drain.common'
      include './com_18/eco.common'
      include './com_18/ecopro.common'
      include './com_18/envi.common'      
      include './com_18/files_car.common'
      include './com_18/files_ibm.common'
      include './com_18/fileunits.common'      
      include './com_18/flux_w.common'
      include './com_18/gene.common'
      include './com_18/gridclim.common'
      include './com_18/icyr.common'      
      include './com_18/input_par.common'
      include './com_18/iprt.common'
      include './com_18/kernel.common'      
      include './com_18/netcdf_par.common'
      include './com_18/nspc.common'
      include './com_18/pathg.common'
      include './com_18/pixdata.common'
      include './com_18/plant_pool.common'      
      include './com_18/pzone.common'
      include './com_18/smrd.common'
      include './com_18/solpar.common'
      include './com_18/sr_par.common'
      include './com_18/varday.common'
      include './com_18/vegfr.common'
      include './com_18/frac_change.common'
      include './com_18/mort.common'
      include './com_18/soil_marie.common'
      
      integer iread,nyrmax,itmt,ngt,iy_past

      real*4 graine
      real*4 stept,tbegin,tend,tmt_it
      real*4 aaa,bbb
      double precision y
      dimension y(nequat)
      character*100 label

      REAL, ALLOCATABLE, DIMENSION(:,:,:) :: xxxx1year


c     default value of nd (number of days in year)
      nd = 365
c     time step for hydrological module (IBM) integration (day)
      stept = 1.

      call open_input5(nyrmax,itmt,stept,iread)
      write(*,*) 'open input file finish'

      if (ifull.eq.1) open(24,file=filres)

c=======================================================================
c   constants
c=======================================================================
      if (iterun .eq.1) then
        call ctgen
        write(*,*) 'ctgen finish'
      
        call monthparam
        write(*,*) 'monthparam finish'
     
        call cth2o
        write(*,*) 'cth2o finish'

        call clasparam
        write(*,*) 'clasparam finish'
      
        call crops_seas
        write(*,*) 'crop_seas finish'
      
c=======================================================================
c   calculates hourly (only) dependent parameters.
c=======================================================================

        call hourly
        write(*,*) 'hourly finish'

        if(itmt.ne.0) tmt_it = nyear/20.

        call open_file(iread)       ! open_file opens all the files and
                                    ! initialises the longitude (zlon)
                                    ! and latitude (zlat) arrays      
   
        if ((imig.eq.1).and.(igtyp.ne.0)) then
          write(*,*)'A regular rectangular grid should be used '
          write(*,*)'when the migration module is called : '    
          write(*,*)'parameters igtyp=',igtyp,' and imig=',imig
          write(*,*)'are not compatible - Program stop'
          write(61,*)'A regular rectangular grid should be used '
          write(61,*)'when the migration module is called : '   
          write(61,*)'parameters igtyp=',igtyp,' and imig=',imig
          write(61,*)'are not compatible - Program stop'
          stop
        endif

        DO ngt = 1, n_pix         ! Read in soil and lon-lat data
          call read_eco(ngt)
        ENDDO

      
c=======================================================================
c   Initializes the CO2 pressure of the previous years
c=======================================================================	
	      
        if ((iread.ge.1)) then
          read(325,*)(co2_prev(iy),iy=1,20)
        endif

c=======================================================================
c   initialisation of the weather generator: calculation of different
c   probabilities for the 176 climatic zones of Koppen or read
c   on unit 23 if ngener is not equal to 1
c=======================================================================

        if (idaily_in.eq.0) then
          if (ngener.eq.1) then
            graine = float(1)
            iprint=0
            call generator(graine,iprint)
          else
            read(23) rapportP
            read(23) rapportT
            read(23) rapportDT
            read(23) ioccu
            read(23) nombrejp
            read(23) nombrejpS
          endif
        endif
        	
      endif !(iterun=1)

      
c=======================================================================
c   Calculates the orbital parameters for a given situation/year
c=======================================================================
      if(ipar.eq.1) call orb_params

c=======================================================================
c   i dont know
c=======================================================================

      IF (idaily_in == 0) THEN
        ntimedata = nm
      ELSE
        ntimedata = nd
      ENDIF
	

      ALLOCATE(tcel1year(ntimedata, n_pix))	
      ALLOCATE(temax1year(ntimedata, n_pix))
      ALLOCATE(temin1year(ntimedata, n_pix))
      ALLOCATE(prc1year(ntimedata, n_pix))	
      ALLOCATE(sunhour1year(ntimedata, n_pix))
      ALLOCATE(rhu1year(ntimedata, n_pix))
      ALLOCATE(win1year(ntimedata, n_pix))

c=======================================================================
c   i dont know
c=======================================================================
		
	    if (num_ncdf.ge.1) then

        IF (iterun == 1) THEN       ! At the beginning of the first year
          
          ALLOCATE(ngt4ilonjlat(nclen_lon,nclen_lat))
          ALLOCATE(ilon4ngt(n_pix))
          ALLOCATE(jlat4ngt(n_pix))
          ngt4ilonjlat(:,:) = -1    ! preset the arrays to the  value -1
          ilon4ngt(:) = -1
          jlat4ngt(:) = -1

          
          DO ngt = 1, n_pix         ! Locate each land grid-point on the
                                    ! lon-lat grid of the NetCDF files
            ncpos_lon_saven = ncpos_lon
            DO WHILE(ABS(xlg(ngt) - zlon(ncpos_lon)) > zdel_lon)
              ncpos_lon = ncpos_lon + 1
              IF (ncpos_lon == nclen_lon + 1) ncpos_lon = 1
              IF (ncpos_lon == ncpos_lon_saven) THEN
                WRITE(*,*) '    Could not find any longitude close to ',
     &                     xlg(ngt)
                WRITE(*,*) '    Aborting.'
                CALL ABORT()
              ENDIF
            ENDDO

            ncpos_lat_saven = ncpos_lat
            DO WHILE(ABS(xlt(ngt) - zlat(ncpos_lat)) > zdel_lat)
              ncpos_lat = ncpos_lat + 1
              IF (ncpos_lat == nclen_lat + 1) ncpos_lat = 1
              IF (ncpos_lat == ncpos_lat_saven) THEN
                WRITE(*,*) '    Could not find any latitude close to ',
     &                     xlt(ngt)
                WRITE(*,*) '    Aborting.'
                CALL ABORT()
              ENDIF
            ENDDO

            ngt4ilonjlat(ncpos_lon,ncpos_lat) = ngt
            ilon4ngt(ngt) = ncpos_lon
            jlat4ngt(ngt) = ncpos_lat

          ENDDO
	  
        ENDIF !(iterun = 1)
	 

        ALLOCATE(xxxx1year(nclen_lon, nclen_lat, ntimedata))

        istart = (/         1,         1, ncpos_time /)
        ncount = (/ nclen_lon, nclen_lat, ntimedata  /)
	 
      endif    !(num_ncdf)	 

c=======================================================================
c   i dont know
c=======================================================================


      if (incdf_tem.eq.1) then
        istatus = NF_GET_VARA_REAL(ncid_filtema, ncvar_tema, 
     &                             istart, ncount, xxxx1year)
        IF (istatus /= NF_NOERR)
     &    CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-3))

        DO i_pix = 1, n_pix
          tcel1year(:, i_pix)
     &    = xxxx1year(ilon4ngt(i_pix), jlat4ngt(i_pix),:)
        ENDDO
	    else

	      DO i_pix = 1, n_pix
           read(iunit_tema,*)aaa,bbb,(tcel1year(k,i_pix),k=1,ntimedata)
        ENDDO

      endif  !(incdf_tem)

c=======================================================================
c   i dont know
c=======================================================================

      if (incdf_dta.eq.1) then
          istatus = NF_GET_VARA_REAL(ncid_fildtaa, ncvar_dtaa,
     &                             istart, ncount, xxxx1year)
        IF (istatus /= NF_NOERR)
     &     CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-3))

        DO i_pix = 1, n_pix
          temax1year(:, i_pix)
     &    = xxxx1year(ilon4ngt(i_pix), jlat4ngt(i_pix),:)
        ENDDO

	    else

	      DO i_pix = 1, n_pix
	        read(iunit_dtaa,*)aaa,bbb,(temax1year(k,i_pix),k=1,ntimedata)
        ENDDO

      endif !(incdf_dta)

c=======================================================================
c   i dont know
c=======================================================================

	 	 
      if (idtem.eq.1) then
        if (incdf_dtb.eq.1) then
          istatus = NF_GET_VARA_REAL(ncid_fildtba, ncvar_dtba,
     &                             istart, ncount, xxxx1year)
          IF (istatus /= NF_NOERR)
     &     CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-3))

          DO i_pix = 1, n_pix
            temin1year(:, i_pix)
     &       = xxxx1year(ilon4ngt(i_pix), jlat4ngt(i_pix),:)
          ENDDO
        else
	        DO i_pix = 1, n_pix
	         read(iunit_dtba,*)aaa,bbb,(temin1year(k,i_pix),k=1,ntimedata)
          ENDDO
    	  endif
	    endif !(idtem)

c=======================================================================
c   i dont know
c=======================================================================

	 
      if (incdf_prc.eq.1) then
        istatus = NF_GET_VARA_REAL(ncid_filprca, ncvar_prca,
     &                             istart, ncount, xxxx1year)
        IF (istatus /= NF_NOERR)
     &     CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-3))

        DO i_pix = 1, n_pix
          prc1year(:, i_pix)
     &    = xxxx1year(ilon4ngt(i_pix), jlat4ngt(i_pix),:)
	        where(prc1year(:,i_pix).gt.0.5e20)
	          prc1year(:, i_pix) = 0. 
	        endwhere
        ENDDO
      else
	      DO i_pix = 1, n_pix
          read(iunit_prca,*)aaa,bbb,(prc1year(k,i_pix),k=1,ntimedata)
        ENDDO
	    endif

c=======================================================================
c   i dont know
c=======================================================================

      if (incdf_shi.eq.1) then
          istatus = NF_GET_VARA_REAL(ncid_filshia, ncvar_shia,
     &                             istart, ncount, xxxx1year)
        IF (istatus /= NF_NOERR)
     &     CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-3))

        DO i_pix = 1, n_pix
          sunhour1year(:, i_pix)
     &      = xxxx1year(ilon4ngt(i_pix), jlat4ngt(i_pix),:)
        ENDDO
      else
	      DO i_pix = 1, n_pix
          read(iunit_shia,*)
     &            aaa,bbb,(sunhour1year(k,i_pix),k=1,ntimedata)
        ENDDO
	    endif

c=======================================================================
c   i dont know
c=======================================================================

      if (incdf_rhu.eq.1) then
          istatus = NF_GET_VARA_REAL(ncid_filrhua, ncvar_rhua,
     &                             istart, ncount, xxxx1year)
        IF (istatus /= NF_NOERR)
     &     CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-3))

        DO i_pix = 1, n_pix
          rhu1year(:, i_pix)
     &      = xxxx1year(ilon4ngt(i_pix), jlat4ngt(i_pix),:)
        ENDDO
      else
	      DO i_pix = 1, n_pix
	        read(iunit_rhua,*)aaa,bbb,(rhu1year(k,i_pix),k=1,ntimedata)
        ENDDO
	    endif

c=======================================================================
c   i dont know
c=======================================================================

      if (incdf_win.eq.1) then
        istatus = NF_GET_VARA_REAL(ncid_filwina, ncvar_wina,
     &                             istart, ncount, xxxx1year)
        IF (istatus /= NF_NOERR)
     &     CALL HANDLE_NCERRORS(istatus, fn_caraib, (__LINE__-3))

        DO i_pix = 1, n_pix
          win1year(:, i_pix)
     &    = xxxx1year(ilon4ngt(i_pix), jlat4ngt(i_pix),:)
        ENDDO
	    else
	      DO i_pix = 1, n_pix
	        read(iunit_wina,*)aaa,bbb,(win1year(k,i_pix),k=1,ntimedata)
        ENDDO
      endif

      ! deallocate after all the tests
      if (num_ncdf.ge.1) DEALLOCATE(xxxx1year)


c#######################################################################
c=======================================================================
c   Loop over the pixels for ....
c=======================================================================
c#######################################################################
	 
      DO ngt = 1, n_pix

c=======================================================================
c   calculates or reads :
c    - coordinates of pixel corners
c    - pixel area
c=======================================================================	
        if (iterun.eq. 1) call pixel_corners(ngt)
	
c=======================================================================
c   reads land use file and 
c   initialization of variables for all pixels
c=======================================================================

        call read_lu(ngt,iread)
	  	 	  
        if (iterun.eq. 1) then
	        call init_frac_and_lai(ngt) 
	        call read_init(iread,ngt)
	      endif
	  
c=======================================================================
c     land use change and associated carbon reservoir changes 
c=======================================================================
	    
	      if (ilu.eq.1) then 
	        call fraction_luc(ngt)    
	        call write_luc(ngt)
	      endif
	  
c=======================================================================
c   reads cover fractions for crops and pastures
c=======================================================================

        if ((ifrac_rd.ne.1).and.(ilu.eq.1)) call read_luspecies(ngt)	  	  
	 
c=======================================================================
c   reads climatological means (for Koppen zone calculation)
c   tcel_clim, tcelkop    : temperature (deg.), 
c   prc_clim, prckop     : precipitation (mm/mo),
c=======================================================================              
        if (idaily_in.eq.0) then 

	        if (num_ncdf.ge.1) then	  
	   
            cpos_lon = ilon4ngt(ngt)
            ncpos_lat = jlat4ngt(ngt)

            istartn = (/ ncpos_lon, ncpos_lat,  1 /)
            ncountn = (/         1,         1, nm /)
	    
	        endif
	   
          if (incdf_tclim.eq.1) then
            istatusn = NF_GET_VARA_REAL(ncid_filtclima, ncvar_tclima, 
     &                                  istartn, ncountn, tcelkop(1:nm))
            IF (istatusn /= NF_NOERR)
     &        CALL HANDLE_NCERRORS(istatusn, fn_caraib, (__LINE__-2))
          else
	          read(iunit_tclim,*)ylongi,ylati,(tcelkop(m),m=1,nm)
          endif
	   

          if (incdf_pclim.eq.1) then
            istatusn = NF_GET_VARA_REAL(ncid_filpclima, ncvar_pclima, 
     &                           istartn, ncountn, prckop(1:nm))
            IF (istatusn /= NF_NOERR)
     &        CALL HANDLE_NCERRORS(istatusn, fn_caraib, (__LINE__-2))
          else
            read(iunit_pclim,*)ylongi,ylati,(prckop(m),m=1,nm)
          endif
	   
c UNIT CONVERSION (monthly climatological values)
          do m = 1, nm
            tcelkop(m) = uc0_tclim + uc1_tclim * tcelkop(m)
            prckop(m) = uc0_pclim + uc1_pclim * prckop(m)
          end do  
c END OF UNIT CONVERSION (monthly climatological values))

          do m = 1, nm
            tcel_clim(m,ngt) = tcelkop(m)
            prc_clim(m,ngt) = prckop(m)
          end do
         
c=======================================================================
c   determines the climate zone for all pixels
c=======================================================================
          if (iczon.eq.1) then 
            iprint=1
            call zonepxl2(iprint)
          else
            if(nyear.eq.1) then
              read(22,*)xxx,yyy,izonepxl
            else
              izonepxl=kzone(ngt)
            endif
          endif
          kzone(ngt)=izonepxl 

        endif  ! endif   idaily_in              
                     
      end do ! end of loop on pixels

c#######################################################################
c=======================================================================
c   i dont know 
c=======================================================================
c#######################################################################

      if(iczon.eq.1.or.iterun.eq.1) close(22)
	   
      if (idaily_in.eq.0) then
		   
        if (incdf_tclim.eq.1) then

          istatusn = NF_CLOSE(ncid_filtclima)
          IF (istatusn /= NF_NOERR)
     &      CALL HANDLE_NCERRORS(istatusn, fn_caraib, (__LINE__-2))
  
        else
	        close(iunit_tclim)
	      endif
	 	 
        if (incdf_pclim.eq.1) then

          istatusn = NF_CLOSE(ncid_filpclima)
          IF (istatusn /= NF_NOERR)
     &      CALL HANDLE_NCERRORS(istatusn, fn_caraib, (__LINE__-2))

        else
          close(iunit_pclim)
	      endif
	 
      endif
	
	    if (num_ncdf.ge.1) then 
        ncpos_lon = 1               ! Reset ncpos_lon and ncpos_lat
        ncpos_lat = 1 
	    endif        

c=======================================================================
c   calculates pixel neighborhood
c=======================================================================
      if (iterun.eq.1) then
        do ngt = 1, n_pix
          call neighborhood_old(ngt)                        
        end do
           
        if(imig.eq.1) then      
          if(isp.eq.8) then
            open(401,file='midpoints_picea.txt')
            open(402,file='probdenswind_picea.txt')
        
            do i = 1, 96
              read(401,*) igrr,midpoint_pi(i) 
              read(402,*) igrr,probdenswind_pi(i)
            enddo 
            
              close(401)
              close(402) 
          endif         
        endif

      endif   !(iterun)
         
      if (((imig.eq.1).and.(isteady.eq.0)).or.
     &      ((imig.eq.1).and.(isteady.eq.1).and.(iterun.ne.1))) 
     &    call read_mig

c#######################################################################
c=======================================================================
c   loop on grid cells for subroutines
c=======================================================================
c#######################################################################
      
      do ngt = 1, n_pix

c=======================================================================
c   reads climatic, vegetation and soil data 
c   and "sets" them into common blocks
c=======================================================================
        igr = ngt
        call read_in(ngt,iread)
        if (jclonly.eq.1) go to 2455
c=======================================================================
c   climate zone corresponding to the studied pixel
c=======================================================================

        izonepxl = kzone(ngt)

c=======================================================================
c   estimates daily climatic conditions
c=======================================================================

        call daily_weather(ngt,iread)

c=======================================================================
c   calculates solar fluxes and related parameters
c=======================================================================

        call solar

        niter=3
        ipr=24
        nprt=nstprt-1
        ny0prv = 0

c=======================================================================
c   Set the number of year for spin up 
c   If for iteration : do X loop else only do it once
c=======================================================================

        if ((itepex.eq.1).and.(isteady.eq.1).and.(readsteady.eq.0)) then 
          nyr_t = 0
        else
          ny0max = 1
          nyr_t = 1
          if ((readsteady.eq.0).and. (itepex.eq.1)) call read_spinup
        endif
	  
c=======================================================================
c   reads or evaluates sowing dates for crops if standard values from 
c   species file ("bagseas") are not used
c=======================================================================	  
	  
	      if (ilu.eq.1) call crop_sowing_dates
	  	  
      ! if first time : do multiple year == spinup
        do ny0 = 1,ny0max
          nyr_t2 = 0
          if(itepex.eq.1 .and. ny0.eq.1 .and. iread.ge.1) nyr_t2 = 1

c=====================================================================72
c   Call subroutine set_frac to set vegetation fraction
c   and calculate albedo & emissivity, rooting depths, fsi,fci,wpi 
c=====================================================================72
	    
          call set_frac(ngt)
	    
c=====================================================================72
c   Call subroutine drainage to initialize drainage calculation
c=====================================================================72

          call drainage(stept)

c=====================================================================72
c   Call subroutine init_c to set initial conditions of the variables
c           in the hydrological module (y, aswday) 
c=====================================================================72

          call init_c(y,ngt)
	    	    
c=====================================================================72
c   Call differential equation solver for hydrological module (IBM) 
c=====================================================================72	    

          tbegin = float(ny0-1)*float(nd)
          tend = tbegin + float(nd)
          call ode(tbegin,tend,y,stept,niter,ipr)
          dn  = tend - float(ny0-1) * float(nd)

c=====================================================================72
c     Call CARAIB routines 
c=====================================================================72

c=======================================================================
c     criteria for PFT establishment
c=======================================================================

          call pft_estab(ngt)

c=======================================================================
c      calculates the external conditions at an hourly time step.
c=======================================================================

          call cal_in

c=======================================================================
c     ponctual data initialisation at zero.
c=======================================================================

          call ponc_init

c=======================================================================
c     carbon pool values
c=======================================================================

          call set_cpools(ngt)
	    
c=======================================================================
c   calculates vegetation phases 
c=======================================================================	    
	    
	        call veg_phases(ngt)	    

c=======================================================================
c     initialization of the lai limitation due to water stress
c=======================================================================
cIngrid201804

          if(ny0.eq.1) call lailim_init

c=======================================================================
c      npp calculation
c=======================================================================
               
          call npp_cal(ngt,ny0,iread,itmt,tmt_it)
	               
c=======================================================================
c      soil respiration calculation
c=======================================================================

          call soil_resp(ngt)
               
c=======================================================================
c      vegetation succession
c=======================================================================
               
          if ((ifrac.eq.1.and.imig.eq.0).or.
     &          (ifrac.eq.1.and.imig.eq.1.and.nyr_t.eq.0)) then 
            call new_frac(ngt)
          endif
	                   
c=======================================================================
c     grid point results
c=======================================================================

          if (ny0.eq.ny0max) then
            call wri_res
          endif

          call record_grid(y,ngt)
	    
           
        enddo ! end of loop on ny0 == end of spinup or year

c=====================================================================72
c      writes results for 1st day of year in output nr 26
c                   (initialization file)
c      writes net budgets for last in output nr 27
c                   (test of convergence file)
c=====================================================================72

        call wri_1st(y,nyear,ngt) 	  
	  
2455      continue	  

      enddo ! end of loop on ngt

c=======================================================================
c      records CO2 of previous years
c=======================================================================
      
      write(326,'(20(1x,f10.3))')(co2_prev(iy),iy=1,20) 
		
c=======================================================================
c      dispersion module
c=======================================================================

      if (imig.eq.1.and.nyr_t.eq.1) call close_mig
         
      if (imig.eq.1.and.nyr_t.eq.1) call open_mig

      if (imig.eq.1.and.nyr_t.eq.1) call dispersion   

c=======================================================================
c      vegetation succession
c=======================================================================

      if (imig.eq.1.and.nyr_t.eq.1) call close_mig
         
      if (imig.eq.1.and.nyr_t.eq.1) call open_mig

      if (ifrac.eq.1.and.imig.eq.1.and.nyr_t.eq.1) 
     &    call new_frac2

      call close_file(iread)
      if(iprt_zon.eq.0) iczon=0
      iread=1
         
      if(itmt.ne.0.and.tmt_it.eq.itmt) itmt = itmt + 1

cc incrementation of day counter (idayct) at the end of year
cc Not incremented anymore: idayct must be read every year in 
cc control file when netcdf files are used) 	 
cc	      idayct = idayct + nd
	      
      DEALLOCATE(tcel1year)
      DEALLOCATE(temax1year)
      DEALLOCATE(temin1year)
      DEALLOCATE(sunhour1year)
      DEALLOCATE(prc1year)
      DEALLOCATE(rhu1year)
      DEALLOCATE(win1year)
      
      if(iclim.eq.1) close(666)
      close(5)
      close(28)
      close(61)
      if (ifull.eq.1) close(24)

      stop
      end subroutine caraib